<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>HowTos/BuildingKernelModules</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">HowTos/BuildingKernelModules</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="en"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><span class="anchor" id="line-4"></span><p class="line867">
<h1 id="Build_Your_Own_Kernel_Modules">Build Your Own Kernel Modules</h1>
<span class="anchor" id="line-5"></span><span class="anchor" id="line-6"></span><p class="line862">Created by <a href="./AkemiYagi.html">AkemiYagi</a>. Currently maintained by <a href="./AlanBartlett.html">AlanBartlett</a> and <a href="./AkemiYagi.html">AkemiYagi</a>. <span class="anchor" id="line-7"></span><span class="anchor" id="line-8"></span><div><table><tbody><tr>  <td style="background-color: #ff0000"><p class="line862">Please note that if you make changes to your kernel, you may no longer get support or help from the CentOS development team.  The procedures described here are not officially endorsed by CentOS.  This tutorial is provided in a hope that it will be useful when building your own kernel modules. </td>
</tr>
</tbody></table></div><span class="anchor" id="line-9"></span><span class="anchor" id="line-10"></span><div><table><tbody><tr>  <td class="lmimg blue" style="padding: 0pt;"><p class="line862"> <a class="attachment" href="attachments/ArtWork(2f)WikiDesign/icon-admonition-info.png" title="{{attachment:ArtWork/WikiDesign/icon-admonition-info.png}}"><img alt="attachment:ArtWork/WikiDesign/icon-admonition-info.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-info.png" title="attachment:ArtWork/WikiDesign/icon-admonition-info.png" /></a> </td>
  <td class="lmtxt blue" colspan="2" style="padding: 0pt;  text-align: left;  vertical-align: top;"><p class="line862">If you  are going to install your own module to a system where Secure Boot is enabled, you'd need to sign it with a private key. See: <a class="https" href="https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Kernel_Administration_Guide/sect-signing-kernel-modules-for-secure-boot.html">Signing Kernel Modules for Secure Boot</a> for more details.</td>
</tr>
</tbody></table></div><span class="anchor" id="line-11"></span><span class="anchor" id="line-12"></span><p class="line867"><div class="table-of-contents"><p class="table-of-contents-heading">Contents<ol><li>
<a href="#Building_a_kernel_module_.28.2A.ko.29">Building a kernel module (*.ko)</a></li><li>
<a href="#Building_a_kernel_module_using_Dynamic_Kernel_Module_Support_.28DKMS.29">Building a kernel module using Dynamic Kernel Module Support (DKMS)</a></li><li>
<a href="#Building_a_kernel_module_rpm_package_.28kmod.29">Building a kernel module rpm package (kmod)</a></li></ol></li></ol></div> <span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> This tutorial was written using CentOS-7 as the example OS. <span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><p class="line874">There are occasions when you need to modify a kernel module or create a new one.  This may be to add certain features or simply to apply a patch.  In this tutorial, we will attempt to apply a bug fix to an existing module and then install it. <span class="anchor" id="line-17"></span><span class="anchor" id="line-18"></span><p class="line862">It is assumed that you already have the full kernel source tree installed. If you followed <strong>Section 2</strong> of <a href="./HowTos(2f)I_need_the_Kernel_Source.html">I need the Kernel Source</a>, it will be found in the directory <tt class="backtick">~/rpmbuild/BUILD/kernel-3.10.0/linux-3.10.0.</tt><tt>`uname&nbsp;-m`</tt><tt class="backtick">/.</tt>  <span class="anchor" id="line-19"></span><span class="anchor" id="line-20"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> You are <strong>strongly</strong> advised <strong>against</strong> performing module building as root. (See: <a class="http" href="http://www.owlriver.com/tips/non-root/">Building Source RPM as non-root under CentOS</a>) <span class="anchor" id="line-21"></span><span class="anchor" id="line-22"></span><p class="line867">
<h2 id="Building_a_kernel_module_.28.2A.ko.29">1. Building a kernel module (*.ko)</h2>
<span class="anchor" id="line-23"></span><span class="anchor" id="line-24"></span><p class="line862">Let us assume, as an example, you are applying a patch to the cifs module which is located in the <tt class="backtick">~/rpmbuild/BUILD/kernel-3.10.0/linux-3.10.0-957.x86_64/fs/cifs/</tt> directory. <span class="anchor" id="line-25"></span><span class="anchor" id="line-26"></span><p class="line874">1. Apply the patch(es) to the source file(s) as required. <span class="anchor" id="line-27"></span><span class="anchor" id="line-28"></span><p class="line862">2. Change to the <strong>root directory of the kernel source </strong>and, if this is the first time the kernel has been compiled, configure the kernel remembering to ensure that the relevant component of the kernel is set, within its configuration file (.conf), to be built as a module. <span class="anchor" id="line-29"></span><span class="anchor" id="line-30"></span><p class="line867"><span class="anchor" id="line-31"></span><span class="anchor" id="line-32"></span><span class="anchor" id="line-33"></span><span class="anchor" id="line-34"></span><pre><span class="anchor" id="line-1"></span>[user@host]$ cd ~/rpmbuild/BUILD/kernel-3.10.0/linux-3.10.0-957.x86_64
<span class="anchor" id="line-2"></span>[user@host linux-3.10.0-957.x86_64]$ make oldconfig
<span class="anchor" id="line-3"></span>[user@host linux-3.10.0-957.x86_64]$ make prepare</pre><span class="anchor" id="line-35"></span><span class="anchor" id="line-36"></span><p class="line874">3. Create the files required for compiling external modules. <span class="anchor" id="line-37"></span><span class="anchor" id="line-38"></span><p class="line867"><span class="anchor" id="line-39"></span><span class="anchor" id="line-40"></span><pre><span class="anchor" id="line-1-1"></span>[user@host linux-3.10.0-957.x86_64]$ make modules_prepare</pre><span class="anchor" id="line-41"></span><span class="anchor" id="line-42"></span><p class="line874">4. Compile the module by specifying the relative path to the module’s Makefile and source code. <span class="anchor" id="line-43"></span><span class="anchor" id="line-44"></span><p class="line867"><span class="anchor" id="line-45"></span><span class="anchor" id="line-46"></span><pre><span class="anchor" id="line-1-2"></span>[user@host linux-3.10.0-957.x86_64]$ make M=fs/cifs</pre><span class="anchor" id="line-47"></span><span class="anchor" id="line-48"></span><p class="line862">Note: The whole directory containing the module can be located anywhere. If, for example, it is in <tt class="backtick">~/mycifs</tt>/ run the following command making sure that you are still in the <strong>root directory of the kernel source</strong>. <span class="anchor" id="line-49"></span><span class="anchor" id="line-50"></span><p class="line867"><span class="anchor" id="line-51"></span><span class="anchor" id="line-52"></span><pre><span class="anchor" id="line-1-3"></span>[user@host linux-3.10.0-957.x86_64]$ make M=~/mycifs</pre><span class="anchor" id="line-53"></span><span class="anchor" id="line-54"></span><p class="line874">5. Unless you have compiled this module for debugging purposes, it should now be stripped of unnecessary symbols. <span class="anchor" id="line-55"></span><span class="anchor" id="line-56"></span><p class="line867"><span class="anchor" id="line-57"></span><span class="anchor" id="line-58"></span><pre><span class="anchor" id="line-1-4"></span>[user@host linux-3.10.0-957.x86_64]$ strip --strip-debug fs/cifs/cifs.ko</pre><span class="anchor" id="line-59"></span><span class="anchor" id="line-60"></span><p class="line862">6. In this example, the file cifs.ko has just been created. As <strong>root</strong>, copy the .ko file to the /lib/modules/&lt;<em>kernel-version</em>&gt;/extra/ directory. <span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><p class="line867"><span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><pre><span class="anchor" id="line-1-5"></span>[root@host linux-3.10.0-957.x86_64]# cp fs/cifs/cifs.ko /lib/modules/`uname -r`/extra</pre><span class="anchor" id="line-65"></span><span class="anchor" id="line-66"></span><p class="line862">7. As <strong>root</strong>, run the depmod command to update the module dependency files. <span class="anchor" id="line-67"></span><span class="anchor" id="line-68"></span><p class="line867"><span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><pre><span class="anchor" id="line-1-6"></span>[root@host linux-3.10.0-957.x86_64]# depmod -a</pre><span class="anchor" id="line-71"></span><span class="anchor" id="line-72"></span><span class="anchor" id="line-73"></span><p class="line867">
<h2 id="Building_a_kernel_module_using_Dynamic_Kernel_Module_Support_.28DKMS.29">2. Building a kernel module using Dynamic Kernel Module Support (DKMS)</h2>
<span class="anchor" id="line-74"></span><span class="anchor" id="line-75"></span><p class="line874">The method described above builds a module for a particular kernel version.  If you upgrade the kernel or change the hardware architecture, you will have to manually build the module once again. The dynamic kernel module support (DKMS) framework is basically a duplicate tree, outside of the kernel source, that holds the source and compiled binaries for a particular module. DKMS can be called on to build, install or uninstall modules. DKMS requires the module source code to be located on your system. The DKMS binary takes care of building and installing the module(s) into any kernel(s) you may have on your system. <span class="anchor" id="line-76"></span><span class="anchor" id="line-77"></span><p class="line862">Here we will use the same example as above and build &amp; install the <tt class="backtick">cifs</tt> module. You will need to assume <strong>root</strong>'s powers for this entire section. <span class="anchor" id="line-78"></span><span class="anchor" id="line-79"></span><p class="line862">1. Install the <tt class="backtick">kernel-devel</tt> package that matches your current kernel. <span class="anchor" id="line-80"></span><span class="anchor" id="line-81"></span><p class="line862">2. Install the <tt class="backtick">dkms</tt> package from the EPEL repository (see <a href="./Repositories.html">Repositories</a>). <span class="anchor" id="line-82"></span><span class="anchor" id="line-83"></span><p class="line862">3. Create a directory <tt class="backtick">/usr/src/&lt;module&gt;-&lt;module-version&gt;/</tt> <span class="anchor" id="line-84"></span><span class="anchor" id="line-85"></span><p class="line867"><span class="anchor" id="line-86"></span><span class="anchor" id="line-87"></span><pre><span class="anchor" id="line-1-7"></span>[root@host]# mkdir /usr/src/cifs-1.45fixed/</pre><span class="anchor" id="line-88"></span><span class="anchor" id="line-89"></span><p class="line874">4. Copy the module's source code to that directory. <span class="anchor" id="line-90"></span><span class="anchor" id="line-91"></span><p class="line867"><span class="anchor" id="line-92"></span><span class="anchor" id="line-93"></span><span class="anchor" id="line-94"></span><pre><span class="anchor" id="line-1-8"></span>[root@host]# cd ~/rpmbuild/BUILD/kernel-2.6.18/linux-2.6.18-i686/fs/cifs
<span class="anchor" id="line-2-1"></span>[root@host cifs]# cp -a * /usr/src/cifs-1.45fixed/</pre><span class="anchor" id="line-95"></span><span class="anchor" id="line-96"></span><p class="line862">5. Create a <tt class="backtick">dkms.conf</tt> file in the directory <tt class="backtick">/usr/src/&lt;module&gt;-&lt;module-version&gt;/</tt> <span class="anchor" id="line-97"></span><span class="anchor" id="line-98"></span><p class="line867"><span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span><span class="anchor" id="line-101"></span><pre><span class="anchor" id="line-1-9"></span>[root@host cifs]# cd /usr/src/cifs-1.45fixed
<span class="anchor" id="line-2-2"></span>[root@host cifs-1.45fixed]# vi dkms.conf</pre><span class="anchor" id="line-102"></span><span class="anchor" id="line-103"></span><p class="line862">The <tt class="backtick">dkms.conf</tt> file will need to contain these lines: <span class="anchor" id="line-104"></span><span class="anchor" id="line-105"></span><p class="line867"><span class="anchor" id="line-106"></span><span class="anchor" id="line-107"></span><span class="anchor" id="line-108"></span><span class="anchor" id="line-109"></span><span class="anchor" id="line-110"></span><span class="anchor" id="line-111"></span><pre><span class="anchor" id="line-1-10"></span>PACKAGE_NAME="cifs"
<span class="anchor" id="line-2-3"></span>PACKAGE_VERSION="1.45fixed"
<span class="anchor" id="line-3-1"></span>BUILT_MODULE_NAME[0]="cifs"
<span class="anchor" id="line-4"></span>DEST_MODULE_LOCATION[0]="/kernel/fs/cifs/"
<span class="anchor" id="line-5"></span>AUTOINSTALL="yes"</pre><span class="anchor" id="line-112"></span><span class="anchor" id="line-113"></span><p class="line862">Note: The <tt class="backtick">DEST_MODULE_LOCATION</tt>[0] line will be ignored during module installation because this will always be to the /lib/modules/&lt;<em>kernel-version</em>&gt;/extra/ directory. This parameter, however, will be used when a module is uninstalled as the location to which the stored, old module (if any) will be restored. <span class="anchor" id="line-114"></span><span class="anchor" id="line-115"></span><p class="line862">6. Add the <tt class="backtick">&lt;module&gt;/&lt;module-version&gt;</tt> to the DKMS tree. <span class="anchor" id="line-116"></span><span class="anchor" id="line-117"></span><p class="line867"><span class="anchor" id="line-118"></span><span class="anchor" id="line-119"></span><pre><span class="anchor" id="line-1-11"></span>[root@host cifs-1.45fixed]# dkms add -m cifs -v 1.45fixed</pre><span class="anchor" id="line-120"></span><span class="anchor" id="line-121"></span><p class="line874">7. Compile the module, under DKMS control. <span class="anchor" id="line-122"></span><span class="anchor" id="line-123"></span><p class="line867"><span class="anchor" id="line-124"></span><span class="anchor" id="line-125"></span><pre><span class="anchor" id="line-1-12"></span>[root@host cifs-1.45fixed]# dkms build -m cifs -v 1.45fixed</pre><span class="anchor" id="line-126"></span><span class="anchor" id="line-127"></span><p class="line874">8. Install the module, again under DKMS control. <span class="anchor" id="line-128"></span><span class="anchor" id="line-129"></span><p class="line867"><span class="anchor" id="line-130"></span><span class="anchor" id="line-131"></span><pre><span class="anchor" id="line-1-13"></span>[root@host cifs-1.45fixed]# dkms install -m cifs -v 1.45fixed</pre><span class="anchor" id="line-132"></span><span class="anchor" id="line-133"></span><p class="line862">Other DKMS actions to note are <tt class="backtick">uninstall</tt>, <tt class="backtick">remove</tt>, <tt class="backtick">status</tt> and <tt class="backtick">mkrpm</tt> which uninstalls the module from the kernel, removes the <tt class="backtick">&lt;module&gt;/&lt;module-version&gt;</tt> from the DKMS tree, displays the current DKMS status of the system and creates a rpm file in the directory <tt class="backtick">/var/lib/dkms/&lt;module&gt;/&lt;module-version&gt;/rpm/</tt> respectively. <span class="anchor" id="line-134"></span><span class="anchor" id="line-135"></span><p class="line874">See also: <span class="anchor" id="line-136"></span><span class="anchor" id="line-137"></span><ul><li><p class="line862">The man page <a class="http" href="http://linux.dell.com/dkms/manpage.html">http://linux.dell.com/dkms/manpage.html</a> <span class="anchor" id="line-138"></span></li><li><p class="line862">The white paper <a class="http" href="http://linux.dell.com/dkms/dkms-ols2004.pdf">http://linux.dell.com/dkms/dkms-ols2004.pdf</a> <span class="anchor" id="line-139"></span><span class="anchor" id="line-140"></span></li></ul><p class="line867">
<h2 id="Building_a_kernel_module_rpm_package_.28kmod.29">3. Building a kernel module rpm package (kmod)</h2>
<span class="anchor" id="line-141"></span><span class="anchor" id="line-142"></span><p class="line874">You can also create rpm files for kernel modules. The kernel module rpm package (kmod) may then be installed by using the rpm command just like any other package. However, rpm packaging of kernel modules is handled differently from the standard packaging process. The example, below, provides the basic kernel module rpm packaging technique. <span class="anchor" id="line-143"></span><span class="anchor" id="line-144"></span><p class="line874">Once again we will use the cifs module as an example and create a set of kmod-cifs rpm files. <span class="anchor" id="line-145"></span><span class="anchor" id="line-146"></span><p class="line862">1. Install <strong>all</strong> the <tt class="backtick">kernel-devel</tt> packages for the kernel version that this package will be built against. <span class="anchor" id="line-147"></span><span class="anchor" id="line-148"></span><p class="line862">2. The patched source code is in the <tt class="backtick">~/rpmbuild/BUILD/kernel-2.6.18/linux-2.6.18.i686/fs/cifs/</tt> directory as in Section 1, above. Make a working copy of that directory. <span class="anchor" id="line-149"></span><span class="anchor" id="line-150"></span><p class="line867"><span class="anchor" id="line-151"></span><span class="anchor" id="line-152"></span><span class="anchor" id="line-153"></span><span class="anchor" id="line-154"></span><pre><span class="anchor" id="line-1-14"></span>[user@host]$ mkdir ~/cifs-1.45/
<span class="anchor" id="line-2-4"></span>[user@host]$ cd ~/rpmbuild/BUILD/kernel-2.6.18/linux-2.6.18.i686/fs/cifs
<span class="anchor" id="line-3-2"></span>[user@host]$ cp -a * ~/cifs-1.45/</pre><span class="anchor" id="line-155"></span><span class="anchor" id="line-156"></span><p class="line874">3. Create a bzip2 compressed tarball containing the source directory. <span class="anchor" id="line-157"></span><span class="anchor" id="line-158"></span><p class="line867"><span class="anchor" id="line-159"></span><span class="anchor" id="line-160"></span><span class="anchor" id="line-161"></span><pre><span class="anchor" id="line-1-15"></span>[user@host]$ cd
<span class="anchor" id="line-2-5"></span>[user@host]$ tar -jcf cifs-1.45.tar.bz2 cifs-1.45/</pre><span class="anchor" id="line-162"></span><span class="anchor" id="line-163"></span><p class="line874">4. Copy the compressed tarball to the SOURCES directory. <span class="anchor" id="line-164"></span><span class="anchor" id="line-165"></span><p class="line867"><span class="anchor" id="line-166"></span><span class="anchor" id="line-167"></span><pre><span class="anchor" id="line-1-16"></span>[user@host]$ cp cifs-1.45.tar.bz2 ~/rpmbuild/SOURCES/</pre><span class="anchor" id="line-168"></span><span class="anchor" id="line-169"></span><p class="line862">5. Make a copy the script <tt class="backtick">kmodtool</tt> (part of the <tt class="backtick">redhat-rpm-config</tt> package) in the SOURCES directory. <span class="anchor" id="line-170"></span><span class="anchor" id="line-171"></span><p class="line867"><span class="anchor" id="line-172"></span><span class="anchor" id="line-173"></span><span class="anchor" id="line-174"></span><pre><span class="anchor" id="line-1-17"></span>[user@host]$ cd ~/rpmbuild/SOURCES/
<span class="anchor" id="line-2-6"></span>[user@host SOURCES]$ cp /usr/lib/rpm/redhat/kmodtool kmodtool-cifs-el5.sh</pre><span class="anchor" id="line-175"></span><span class="anchor" id="line-176"></span><p class="line862">6. Edit your copy of the <tt class="backtick">kmodtool-cifs-el5.sh</tt> file to ensure that the line referencing <tt class="backtick">kmod-common</tt> is commented out and to add a line that expands to become a reference to a <tt class="backtick">kmod-cifs.conf</tt> file under the <em>%files</em> section. <span class="anchor" id="line-177"></span><span class="anchor" id="line-178"></span><p class="line867"><span class="anchor" id="line-179"></span><span class="anchor" id="line-180"></span><pre><span class="anchor" id="line-1-18"></span>[user@host SOURCES]$ vi kmodtool-cifs-el5.sh</pre><span class="anchor" id="line-181"></span><span class="anchor" id="line-182"></span><p class="line874">Line 105 onwards -- <span class="anchor" id="line-183"></span><span class="anchor" id="line-184"></span><p class="line867"><span class="anchor" id="line-185"></span><span class="anchor" id="line-186"></span><span class="anchor" id="line-187"></span><span class="anchor" id="line-188"></span><span class="anchor" id="line-189"></span><pre><span class="anchor" id="line-1-19"></span>#
<span class="anchor" id="line-2-7"></span># RHEL5 - Remove common package requirement on general kmod packages.
<span class="anchor" id="line-3-3"></span># Requires: ${kmod_name}-kmod-common &gt;= %{?epoch:%{epoch}:}%{version}
<span class="anchor" id="line-4-1"></span>#</pre><span class="anchor" id="line-190"></span><span class="anchor" id="line-191"></span><p class="line874">Line 168 onwards -- <span class="anchor" id="line-192"></span><span class="anchor" id="line-193"></span><p class="line867"><span class="anchor" id="line-194"></span><span class="anchor" id="line-195"></span><span class="anchor" id="line-196"></span><span class="anchor" id="line-197"></span><span class="anchor" id="line-198"></span><span class="anchor" id="line-199"></span><span class="anchor" id="line-200"></span><span class="anchor" id="line-201"></span><span class="anchor" id="line-202"></span><span class="anchor" id="line-203"></span><span class="anchor" id="line-204"></span><span class="anchor" id="line-205"></span><span class="anchor" id="line-206"></span><span class="anchor" id="line-207"></span><pre><span class="anchor" id="line-1-20"></span>echo "%files         -n kmod-${kmod_name}${dashvariant}"
<span class="anchor" id="line-2-8"></span>if [ "" == "$kmp_override_filelist" ];
<span class="anchor" id="line-3-4"></span>then
<span class="anchor" id="line-4-2"></span>    echo "%defattr(644,root,root,755)"
<span class="anchor" id="line-5-1"></span>    echo "/lib/modules/${verrel}${variant}/"
<span class="anchor" id="line-6"></span>    echo "%config /etc/depmod.d/kmod-${kmod_name}.conf"
<span class="anchor" id="line-7"></span>    #BZ252188 - I've commented this out for the moment since RHEL5 doesn't
<span class="anchor" id="line-8"></span>    #           really support external firmware e.g. at install time. If
<span class="anchor" id="line-9"></span>    #           you really want it, use an override filelist solution.
<span class="anchor" id="line-10"></span>    #echo "/lib/firmware/"
<span class="anchor" id="line-11"></span>else
<span class="anchor" id="line-12"></span>    cat "$kmp_override_filelist"
<span class="anchor" id="line-13"></span>fi</pre><span class="anchor" id="line-208"></span><span class="anchor" id="line-209"></span><p class="line862">7. Create a <tt class="backtick">cifs-kmod.spec</tt> file in the SPECS directory. <span class="anchor" id="line-210"></span><span class="anchor" id="line-211"></span><p class="line867"><span class="anchor" id="line-212"></span><span class="anchor" id="line-213"></span><span class="anchor" id="line-214"></span><pre><span class="anchor" id="line-1-21"></span>[user@host SOURCES]$ cd ~/rpmbuild/SPECS/
<span class="anchor" id="line-2-9"></span>[user@host SPECS]$ vi cifs-kmod.spec</pre><span class="anchor" id="line-215"></span><span class="anchor" id="line-216"></span><p class="line867"><span class="anchor" id="line-217"></span><span class="anchor" id="line-218"></span><span class="anchor" id="line-219"></span><span class="anchor" id="line-220"></span><span class="anchor" id="line-221"></span><span class="anchor" id="line-222"></span><span class="anchor" id="line-223"></span><span class="anchor" id="line-224"></span><span class="anchor" id="line-225"></span><span class="anchor" id="line-226"></span><span class="anchor" id="line-227"></span><span class="anchor" id="line-228"></span><span class="anchor" id="line-229"></span><span class="anchor" id="line-230"></span><span class="anchor" id="line-231"></span><span class="anchor" id="line-232"></span><span class="anchor" id="line-233"></span><span class="anchor" id="line-234"></span><span class="anchor" id="line-235"></span><span class="anchor" id="line-236"></span><span class="anchor" id="line-237"></span><span class="anchor" id="line-238"></span><span class="anchor" id="line-239"></span><span class="anchor" id="line-240"></span><span class="anchor" id="line-241"></span><span class="anchor" id="line-242"></span><span class="anchor" id="line-243"></span><span class="anchor" id="line-244"></span><span class="anchor" id="line-245"></span><span class="anchor" id="line-246"></span><span class="anchor" id="line-247"></span><span class="anchor" id="line-248"></span><span class="anchor" id="line-249"></span><span class="anchor" id="line-250"></span><span class="anchor" id="line-251"></span><span class="anchor" id="line-252"></span><span class="anchor" id="line-253"></span><span class="anchor" id="line-254"></span><span class="anchor" id="line-255"></span><span class="anchor" id="line-256"></span><span class="anchor" id="line-257"></span><span class="anchor" id="line-258"></span><span class="anchor" id="line-259"></span><span class="anchor" id="line-260"></span><span class="anchor" id="line-261"></span><span class="anchor" id="line-262"></span><span class="anchor" id="line-263"></span><span class="anchor" id="line-264"></span><span class="anchor" id="line-265"></span><span class="anchor" id="line-266"></span><span class="anchor" id="line-267"></span><span class="anchor" id="line-268"></span><span class="anchor" id="line-269"></span><span class="anchor" id="line-270"></span><span class="anchor" id="line-271"></span><span class="anchor" id="line-272"></span><span class="anchor" id="line-273"></span><span class="anchor" id="line-274"></span><span class="anchor" id="line-275"></span><span class="anchor" id="line-276"></span><span class="anchor" id="line-277"></span><span class="anchor" id="line-278"></span><span class="anchor" id="line-279"></span><span class="anchor" id="line-280"></span><span class="anchor" id="line-281"></span><span class="anchor" id="line-282"></span><span class="anchor" id="line-283"></span><span class="anchor" id="line-284"></span><span class="anchor" id="line-285"></span><span class="anchor" id="line-286"></span><span class="anchor" id="line-287"></span><span class="anchor" id="line-288"></span><span class="anchor" id="line-289"></span><span class="anchor" id="line-290"></span><span class="anchor" id="line-291"></span><span class="anchor" id="line-292"></span><span class="anchor" id="line-293"></span><span class="anchor" id="line-294"></span><span class="anchor" id="line-295"></span><span class="anchor" id="line-296"></span><span class="anchor" id="line-297"></span><span class="anchor" id="line-298"></span><span class="anchor" id="line-299"></span><span class="anchor" id="line-300"></span><span class="anchor" id="line-301"></span><pre><span class="anchor" id="line-1-22"></span># Define the kmod package name here.
<span class="anchor" id="line-2-10"></span>%define kmod_name cifs
<span class="anchor" id="line-3-5"></span>
<span class="anchor" id="line-4-3"></span># If kversion isn't defined on the rpmbuild line, define it here.
<span class="anchor" id="line-5-2"></span>%{!?kversion: %define kversion 2.6.18-8.el5}
<span class="anchor" id="line-6-1"></span>
<span class="anchor" id="line-7-1"></span>Name:    %{kmod_name}-kmod
<span class="anchor" id="line-8-1"></span>Version: 1.45
<span class="anchor" id="line-9-1"></span>Release: 1%{?dist}
<span class="anchor" id="line-10-1"></span>Group:   System Environment/Kernel
<span class="anchor" id="line-11-1"></span>License: GPLv2
<span class="anchor" id="line-12-1"></span>Summary: %{kmod_name} kernel module(s)
<span class="anchor" id="line-13-1"></span>URL:     http://www.centos.org/
<span class="anchor" id="line-14"></span>
<span class="anchor" id="line-15"></span>BuildRequires: redhat-rpm-config
<span class="anchor" id="line-16"></span>BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
<span class="anchor" id="line-17"></span>ExclusiveArch: i686 x86_64
<span class="anchor" id="line-18"></span>
<span class="anchor" id="line-19"></span># Sources.
<span class="anchor" id="line-20"></span>Source0:  %{kmod_name}-%{version}.tar.bz2
<span class="anchor" id="line-21"></span>Source10: kmodtool-%{kmod_name}-el5.sh
<span class="anchor" id="line-22"></span>
<span class="anchor" id="line-23"></span># Define the variants for each architecture.
<span class="anchor" id="line-24"></span>%define basevar ""
<span class="anchor" id="line-25"></span>%ifarch i686
<span class="anchor" id="line-26"></span>%define paevar PAE
<span class="anchor" id="line-27"></span>%endif
<span class="anchor" id="line-28"></span>%ifarch i686 x86_64
<span class="anchor" id="line-29"></span>%define xenvar xen
<span class="anchor" id="line-30"></span>%endif
<span class="anchor" id="line-31"></span>
<span class="anchor" id="line-32"></span># If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
<span class="anchor" id="line-33"></span>%{!?kvariants: %define kvariants %{?basevar} %{?xenvar} %{?paevar}}
<span class="anchor" id="line-34"></span>
<span class="anchor" id="line-35"></span># Magic hidden here.
<span class="anchor" id="line-36"></span>%{expand:%(sh %{SOURCE10} rpmtemplate_kmp %{kmod_name} %{kversion} %{kvariants})}
<span class="anchor" id="line-37"></span>
<span class="anchor" id="line-38"></span># Disable the building of the debug package(s).
<span class="anchor" id="line-39"></span>%define debug_package %{nil}
<span class="anchor" id="line-40"></span>
<span class="anchor" id="line-41"></span># Define the filter.
<span class="anchor" id="line-42"></span>%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh
<span class="anchor" id="line-43"></span>
<span class="anchor" id="line-44"></span>%description
<span class="anchor" id="line-45"></span>This package provides the CentOS-5 bug-fixed %{kmod_name} kernel module (bug #1776).
<span class="anchor" id="line-46"></span>It is built to depend upon the specific ABI provided by a range of releases
<span class="anchor" id="line-47"></span>of the same variant of the Linux kernel and not on any one specific build.
<span class="anchor" id="line-48"></span>
<span class="anchor" id="line-49"></span>%prep
<span class="anchor" id="line-50"></span>%setup -q -c -T -a 0
<span class="anchor" id="line-51"></span>for kvariant in %{kvariants} ; do
<span class="anchor" id="line-52"></span>    %{__cp} -a %{kmod_name}-%{version} _kmod_build_$kvariant
<span class="anchor" id="line-53"></span>done
<span class="anchor" id="line-54"></span>echo "/usr/lib/rpm/redhat/find-requires | %{__sed} -e '/^ksym.*/d'" &gt; filter-requires.sh
<span class="anchor" id="line-55"></span>echo "override %{kmod_name} * weak-updates/%{kmod_name}" &gt; kmod-%{kmod_name}.conf
<span class="anchor" id="line-56"></span>
<span class="anchor" id="line-57"></span>%build
<span class="anchor" id="line-58"></span>for kvariant in %{kvariants} ; do
<span class="anchor" id="line-59"></span>    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}
<span class="anchor" id="line-60"></span>    %{__make} -C "${KSRC}" %{?_smp_mflags} modules M=$PWD/_kmod_build_$kvariant
<span class="anchor" id="line-61"></span>done
<span class="anchor" id="line-62"></span>
<span class="anchor" id="line-63"></span>%install
<span class="anchor" id="line-64"></span>%{__rm} -rf %{buildroot}
<span class="anchor" id="line-65"></span>export INSTALL_MOD_PATH=%{buildroot}
<span class="anchor" id="line-66"></span>export INSTALL_MOD_DIR=extra/%{kmod_name}
<span class="anchor" id="line-67"></span>for kvariant in %{kvariants} ; do
<span class="anchor" id="line-68"></span>    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}
<span class="anchor" id="line-69"></span>    %{__make} -C "${KSRC}" modules_install M=$PWD/_kmod_build_$kvariant
<span class="anchor" id="line-70"></span>done
<span class="anchor" id="line-71"></span>%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
<span class="anchor" id="line-72"></span>%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
<span class="anchor" id="line-73"></span># Set the module(s) to be executable, so that they will be stripped when packaged.
<span class="anchor" id="line-74"></span>find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
<span class="anchor" id="line-75"></span>
<span class="anchor" id="line-76"></span>%clean
<span class="anchor" id="line-77"></span>%{__rm} -rf %{buildroot}
<span class="anchor" id="line-78"></span>
<span class="anchor" id="line-79"></span>%changelog
<span class="anchor" id="line-80"></span>* Wed Jan 05 2011 Alan Bartlett &lt;ajb@elrepo.org&gt; - 1.45
<span class="anchor" id="line-81"></span>- Revised this specification file.
<span class="anchor" id="line-82"></span>
<span class="anchor" id="line-83"></span>* Fri May 18 2007 Akemi Yagi &lt;toracat@centos.org&gt; - 1.45
<span class="anchor" id="line-84"></span>- Initial el5 build of the kmod package.</pre><span class="anchor" id="line-302"></span><span class="anchor" id="line-303"></span><p class="line874">8. Build the package. <span class="anchor" id="line-304"></span><span class="anchor" id="line-305"></span><p class="line867"><span class="anchor" id="line-306"></span><span class="anchor" id="line-307"></span><pre><span class="anchor" id="line-1-23"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-308"></span><span class="anchor" id="line-309"></span><p class="line874">If you do not wish to build the kmod packages for your currently running kernel, you can specify the the kernel version on the command line. For example: <span class="anchor" id="line-310"></span><span class="anchor" id="line-311"></span><p class="line867"><span class="anchor" id="line-312"></span><span class="anchor" id="line-313"></span><pre><span class="anchor" id="line-1-24"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` --define 'kversion 2.6.18-371.el5' cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-314"></span><span class="anchor" id="line-315"></span><p class="line874">will build the kmod packages for the 2.6.18-371.el5 kernel. <span class="anchor" id="line-316"></span><span class="anchor" id="line-317"></span><p class="line874">On CentOS 7 and newer, with the in-tree kmodtool script, you should provide the kernel version like the following <span class="anchor" id="line-318"></span><span class="anchor" id="line-319"></span><p class="line867"><span class="anchor" id="line-320"></span><span class="anchor" id="line-321"></span><pre><span class="anchor" id="line-1-25"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` --define 'kernel_version 3.10.0-862.el7' cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-322"></span><span class="anchor" id="line-323"></span><p class="line874">which will build the kmod package for the 3.10.0-862.el7 kernel. <span class="anchor" id="line-324"></span><span class="anchor" id="line-325"></span><p class="line874">In a similar fashion, you may select which kernel-variant kmod package(s) to build. For example: <span class="anchor" id="line-326"></span><span class="anchor" id="line-327"></span><p class="line867"><span class="anchor" id="line-328"></span><span class="anchor" id="line-329"></span><pre><span class="anchor" id="line-1-26"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` --define 'kvariants ""' cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-330"></span><span class="anchor" id="line-331"></span><p class="line874">will build just the base-kernel kmod package. <span class="anchor" id="line-332"></span><span class="anchor" id="line-333"></span><p class="line862">When the build completes, there will be a set of <tt class="backtick">kmod-cifs</tt> rpm files in the <tt class="backtick">~/rpmbuild/RPMS/</tt><tt>`uname&nbsp;-m`</tt><tt class="backtick">/</tt> directory. <span class="anchor" id="line-334"></span><span class="anchor" id="line-335"></span><p class="line874">See also: <span class="anchor" id="line-336"></span><span class="anchor" id="line-337"></span><ul><li><p class="line862">Official reference guide for the Red Hat Driver Update Packages, based on RHEL 6 <a class="http" href="http://people.redhat.com/jcm/el6/dup/docs/dup_book.pdf">http://people.redhat.com/jcm/el6/dup/docs/dup_book.pdf</a> <span class="anchor" id="line-338"></span></li><li><p class="line862">General rpm building from Fedora <a class="https" href="https://docs.fedoraproject.org/en-US/quick-docs/creating-rpm-packages/">https://docs.fedoraproject.org/en-US/quick-docs/creating-rpm-packages/</a> <span class="anchor" id="line-339"></span></li><li><p class="line862">An obsoleted page about building kernel module RPM from Fedora, just for reference. <a class="http" href="http://fedoraproject.org/wiki/Obsolete/KernelModules">http://fedoraproject.org/wiki/Obsolete/KernelModules</a> <span class="anchor" id="line-340"></span></li></ul><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:22
</body>
</html>
